var readline = require("readline-sync")

var forza4 = [];
var nColonne = 7;
var nLinee = 6;
var player1 = "x";
var player2 = "o";

forza4 = initTable(nLinee, nColonne, 0);
mostraForza4(forza4, player1, player2);

while(true)
{
    if(gameCase(1))
    {
        console.log("Il player 1 ha vinto");
        break;
    }
    if(gameCase(2))
    {
        console.log("Il player 2 ha vinto");
        break;
    }
}

/**
 * Verifica che il giocatore 1 sta in game
 * @param {*} player 
 * @returns 
 */
function gameCase(player)
{
    var lineaVuota = -1;
    var colonna = -1;
    while(lineaVuota === -1 || colonna <= 0 || colonna > 7)
    {
        console.log("Scegliere una colonna in una zona vuota");
        var colonna = scegliereColonna();
        var lineaVuota = ritornaLineaCasellaVuotaColonna(colonna);
    }
    forza4[lineaVuota][colonna-1] = player;
    mostraForza4(forza4, player1, player2);
    return verificaFineDelGioco();
}

function scegliereColonna()
{
    return parseInt(readline.question("Qual'e' la colonna scelta?"));
}

/**
 * Funzione che permette di ottenere la prima linea VUOTA di una colonna
 * @param {*} colonna ritorna -1 se la colonna è piena
 * @returns 
 */
function ritornaLineaCasellaVuotaColonna(colonna)
{
    for(var i = nLinee-1; i >= 0; i--)
    {
        if(verificaCasellaVuota(i, colonna)) return i;
    }
    return -1;
}

/**
 * Funzione che permette di otenere se una casella è vuota (ritorna true/false)
 * @param {*} linea 
 * @param {*} colonna 
 * @returns 
 */
function verificaCasellaVuota(linea, colonna)
{
    return forza4[linea][colonna-1] === 0;
}

function verificaFineDelGioco()
{
    return false;
}

/**
 * Permette di initializzare una tabella in una tabella in funzione di un numero di linee e di colonne messe come parametri
 * @param {*} nLinee 
 * @param {*} nColonne 
 * @param {*} element 
 * @returns 
 */
function initTable(nLinee, nColonne, element = '')
{
    var tab = [];
    for(var i = 0; i < nLinee; i++) 
    {
        var linea = [];
        for(var j = 0; j < nColonne; j++)
        {
            linea.push(element);
        }
        tab.push(linea);
    }
    return tab;
}

/**
 * Permette di mostrare una tabella in stile forza 4
 * @param {*} tab 
 * @param {*} p1el 
 * @param {*} p2el 
 */
function mostraForza4(tab, p1el, p2el)
{
    for(var i = 0; i < tab.length; i++)
    {
        var linea = "";
        for(var j = 0; j < tab[i].length; j++)
        {
            linea += "| ";
            if(tab[i][j] === 0) 
            {
                linea += "_";
            }
            else if(tab[i][j] === 1) 
            {
                linea += p1el;
            }
            else if(tab[i][j] === 2) 
            {
                linea += p2el;
            }
            linea += "| ";
        }
        console.log(linea);
    }
}